# Compact & Adjustable Linux kernel for Archlinux

## linux-spica kernel Overview

linux-spica커널은 특정 하드웨어 플랫폼을 타겟으로 하는 한 아주작은 커널입니다.

커널설정은 다음과 같은 원칙으로 구성되어 있습니다.

1. 모듈기능을 제거 - 초기 부팅과정 보호
2. 해당 플랫폼에 적용되지 않는 설정 제거
3. [바닐라 커널](https://www.kernel.org/)의 main-line을 따라감
4. 하드웨어 이슈, 특정 버전의 오류, 퍼포먼스를 위해 커스텀패치가 적용
    - BFQ패치, GCC컴파일 옵션패치 적용
    - 특정버전에서의 bug, 특정 하드웨어의 errata 등의 패치 적용
5. 서버에서 이용하지 않는 레거시 지원은 모두 제거
    - 오래된 바이너리, 레거시 지원에 대한 코드는 제외

## linux-spica-e3-1230v3 메인타겟
- CPU : intel xeon e3-1230v3
- Memory : Samsung unbuffered ECC DDR3 4GB x 4
- MotherBoard: Supermicro(R) X10SLL-F

## 적용 가능 한 플랫폼
- Intel Haswell Xeon E3 (E3 1200-v3 계열) 기반 
- C222 PCH 기반

## 테스트된 부트로더

1. systemd-boot(권장)
    - systemd내부에 내장되어 있습니다.(추가 패키지 설치 불필요)
    - 모든 커널요소 초기화가 EFI파티션에서 완결됩니다.
    - linux cmdline 설정이 간편합니다.
    - intel-ucode 적용이 쉽습니다.
    - 문제 발생시 배포판 기본 커널로 부팅이 가능합니다.
2. grub
    - 대부분의 장점을 systemd-boot 과 공유합니다.
    - grub 의존성때문에 루트파티션 문제시 부팅과정에 문제가 생길 수 있습니다.
2. EFI-stub
    - ELF-stub이 적용되어 UEFI에서 직접로딩 할 수 있습니다.
    - linux cmdline 설정을 바이오스 내부에 설정해야만 합니다(efibootmgr 또는 uefi shell 이용)
    - intel-ucode를 커널 컴파일시 내장해야됩니다.

## 참고

- aur 리포지토리의 linux-git 소스를 참고하였습니다.

